<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Teilnehmer\VorgesetzteAnmeldungenGenehmigen\BelegungsUebersicht;

class SaveBelegungenController extends \Kufer\Web\KuferTools\Basis\Controller\ToolController
{
  protected function getUseCase(): \Kufer\Web\KuferTools\Basis\UseCase\UseCase
  {
    return new SaveBelegungenUseCase(
      $this->getRequestObj()
    );
  }

  protected function getRequestObj()
  {
    $requestObj = new SaveBelegungenRequest();
    
    $requestObj->bemerkungen = \PostOperations::getVarValue('bemerkung');
    $requestObj->genehmigungen = \PostOperations::getVarValue('genehmigung');

    return $requestObj;
  }

  protected function getControllerToForward($pUseCaseResponse)
  {
    
    if ($pUseCaseResponse->success) {
      $statusCode = \Kufer\Web\KuferTools\Teilnehmer\ZsaTeilnehmerUebersicht\AendereBelegung\AendereBelegungUseCase::UPDATE_BELEGUNG_SUCCESS;
    } else {
      $statusCode = \Kufer\Web\KuferTools\Teilnehmer\ZsaTeilnehmerUebersicht\AendereBelegung\AendereBelegungUseCase::UPDATE_BELEGUNG_ERROR;
    }

    return new BelegungsUebersichtNachAbsendenController($statusCode);
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return null;
  }
}